///////////////////////////////////////////////////////////////////
//	depMatrix.h:	to read each line and find out included files//
//					add them to the file independence matrix	 //
//	ver 1.0														 //
//	Language:		Visual C++, ver 6.0							 //
//	Platform:													 //
//	Application:	CSE687 projet 1								 //
//	Author:			Qiang Zheng, qzheng@syr.edu					 //
///////////////////////////////////////////////////////////////////

#ifndef __DEP_MATRIX_INCLUDED
#define __DEP_MATRIX_INCLUDED

#include <string.h>	//for strlen, strcpy

inline char *newStr( const char *s )
{
	char *temp = new char[strlen(s)+1];
	strcpy( temp, s );
	return temp;
}

class depMatrix 
{
public:
	// constructors and destructor
	depMatrix();
	~depMatrix();

	int getSize();

	int indexOf( const char * , bool);

	void setDependence( int src, int dst );

	void outputDependence();

protected:
	//the size of the matrix is (size * size);
	int size;

	//the adjecent matrix to represent the dependece relation
	//Here an one dimension array is used to simulate a matrix
	//e.g. to express matrix[i][j], dependence[i*size+j] is used
	bool *dependence;

	bool *printRequired;

	// The file name list being analysed
	char **fileNames;
private:
	void swap( int, int );
	void adjust();
};

#endif //__DEP_MATRIX_INCLUDED