///////////////////////////////////////////////////////////////////
//	depStream.h:	to read each line and find out included files//
//					add them to the file independence matrix	 //
//	ver 1.0														 //
//	Language:		Visual C++, ver 6.0							 //
//	Platform:													 //
//	Application:	CSE687 projet 1								 //
//	Author:			Qiang Zheng, qzheng@syr.edu					 //
///////////////////////////////////////////////////////////////////

#ifndef __DEP_STREAM_INCLUDED
#define __DEP_STREAM_INCLUDED

#include <fstream.h>
#include "depMatrix.h"

class depStream : public ifstream
{
public:
	// constructors and destructor
	depStream();
	depStream( const char* szName );
	~depStream();

	//open the file designated by the filename and set up 
	//the index of this file in the dependence matrix
	void open( const char * );

	// scan each line of the file for the file name being
	// included and put it into the dependence matrix
	void parseIt();
	
	// an object to represent the file dependence relation
	// see the depMatrix.h to get more detailed explanation
	static depMatrix dependence;

private:
	// the name of the file associated with this object
	char *fileName;

	// to indicate the index of this file in the
	// dependence matrix
	int index;

	// to look for "#include" in a string
	bool foundPrefix( const char *, int & );

	// look for the included file name between '<' and '>',
	// or between '\"' and '\"'
	bool getFileName( const char *, char *, int );
};

#endif //__DEP_STREAM_INCLUDED